<?php

namespace JetBackup\Queue;

if (!defined( '__JETBACKUP__')) die('Direct access is not allowed');

class QueueItemBackup extends aQueueItem {
	
	const JOB_ID = 'job_id';
	const SNAPSHOT_NAME = 'snapshot_name';
	const DESTINATIONS = 'destinations';
	const DUMP_LAST_TABLE = 'dump_last_table';
	const DATABASE_TABLES = 'database_tables';
	const MANUALLY = 'manually';
	const AFTER_JOB_DONE = 'after_job_done';
	const REVISION_CLEANUP_DONE = 'revision_cleanup_done';
	const TYPE = 'type';

	public function setType(int $type):void { $this->set(self::TYPE, $type); }
	public function getType():int { return (int) $this->get(self::TYPE, 0); }
	public function setJobId(int $_id):void { $this->set(self::JOB_ID, $_id); }
	public function getJobId():int { return (int) $this->get(self::JOB_ID, 0); }

	public function setSnapshotName(string $name):void { $this->set(self::SNAPSHOT_NAME, $name); }
	public function getSnapshotName():string { return $this->get(self::SNAPSHOT_NAME); }

	public function setDestinations(array $destinations):void {$this->set(self::DESTINATIONS, $destinations);}
	public function getDestinations():array {return $this->get(self::DESTINATIONS, []);}

	public function setDatabaseTables(array $tables):void { $this->set(self::DATABASE_TABLES, $tables); }
	public function getDatabaseTables():array { return $this->get(self::DATABASE_TABLES, []); }

	public function setLastDumpedTable(string $table):void { $this->set(self::DUMP_LAST_TABLE, $table); }
	public function getLastDumpedTable():string { return $this->get(self::DUMP_LAST_TABLE); }

	public function setManually(bool $manually):void { $this->set(self::MANUALLY, $manually); }
	public function isManually():bool { return !!$this->get(self::MANUALLY, false); }

	public function setAfterJobDone(bool $job_done):void { $this->set(self::AFTER_JOB_DONE, $job_done); }
	public function isAfterJobDone():bool { return !!$this->get(self::AFTER_JOB_DONE, false); }

	public function setRevisionCleanupDone(bool $value):void { $this->set(self::REVISION_CLEANUP_DONE, !!$value); }
	public function isRevisionCleanupDone():bool { return !!$this->get(self::REVISION_CLEANUP_DONE, false); }

	public function getDisplay():array {
		return [
			self::JOB_ID                => $this->getJobId(),
			self::SNAPSHOT_NAME         => $this->getSnapshotName(),
			self::DESTINATIONS          => $this->getDestinations(),
			self::DATABASE_TABLES       => $this->getDatabaseTables(),
			self::DUMP_LAST_TABLE       => $this->getLastDumpedTable(),
			self::MANUALLY              => $this->isManually(),
			self::AFTER_JOB_DONE        => $this->isAfterJobDone(),
			self::REVISION_CLEANUP_DONE => $this->isRevisionCleanupDone(),
		];
	}
}
