<?php

namespace JetBackup\Restore;

if (!defined( '__JETBACKUP__')) die('Direct access is not allowed');

class PostRestoreActions {

	/**
	 * WordPress post restore actions
	 * Each action is represented by a function
	 */
	private function __construct() {}

	/**
	 * @return void
	 * Elementor clear & rebuild css
	 */
	public static function elementor(){
		add_action('elementor/init', function() {
			\Elementor\Plugin::$instance->files_manager->clear_cache();
		});
		do_action('elementor/init');
	}

	/**
	 * @return void
	 * Flush rewrite rules (in case permalinks break)
	 */
	public static function wpcore(){
		if (function_exists('flush_rewrite_rules')) flush_rewrite_rules();
	}

	/**
	 * @return void
	 * WooCommerce specific actions
	 */
	public static function woocommerce() {

		if (function_exists('wc_update_product_lookup_tables')) {
			wc_update_product_lookup_tables();
		}

		if (function_exists('wc_update_order_stats')) {
			wc_update_order_stats();
		}

		if (function_exists('WC_Install') && method_exists('WC_Install', 'needs_db_update') && WC_Install::needs_db_update()) {
			WC_Install::update();
		}


	}

}